<?php

set_include_path(get_include_path() . PATH_SEPARATOR . 'phpseclib');
include_once('Net/SSH2.php');

global $wpdb;

/**
@package Acclaim-Cloud-Platform-Pro
*/

/*
Plugin Name: Acclaim Cloud Platform Pro
Plugin URI:  https://acclaimconsulting.com/?page_id=873
Description: Acclaim Cloud Platform Pro Plugin
Author:      Acclaim Consulting Group
Author URI:  https://acclaimconsulting.com
Version:     1.7
Text Domain: acclaim-cloud-platform-pro
Domain Path: /languages
License:     GPLv2 or later

Acclaim Cloud Platform is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Acclaim Cloud Platform. If not, see http://www.gnu.org/licenses/gpl-2.0.html
*/

register_activation_hook( __FILE__, 'acppro_db_init' );
register_deactivation_hook( __FILE__, 'acppro_db_deactivate' );
register_uninstall_hook( __FILE__, 'acppro_db_remove' );

// This is the secret key for API authentication.
define('ACP_LICENSE_AUTH_SECRET_KEY', 'lQyZ76EiwH3JASVzod6TgPtvxV1zcUPM'); 

// This is the secret key for creating Development Licenses.
define('ACP_LICENSE_CREATE_SECRET_KEY', 'BXcbNw65l9Iwi77SkNQaH5BfisaAhEv5');

// This is the URL where API query request will be sent to. 
define('ACP_LICENSE_SERVER_URL', 'https://acclaimconsulting.com'); 

// This is a value that will be recorded in the license manager data so you can identify licenses for this item/product.
define('ACP_LICENSE_REFERENCE', 'ACP Pro'); 

define('ACP_LICENSE_KEY_NAME', 'acppro_license_key');

define('ACPPRO_PLUGIN_SETTINGS_ERROR',"<div class='update-nag notice'><p>Acclaim Cloud Platform Pro Plugin setup is incomplete. Please go to Settings -> ACP Pro Key and Get a Free License</p></div>");

//create table when plugin is activated
function acppro_db_init() {

        global $wpdb;

        global $acppro_db_version;
        $acppro_db_version = '1.7';
        require_once(ABSPATH . 'wp-admin/includes/upgrade.php' );

	//if(null == get_option(ACP_LICENSE_KEY_NAME)) {

                add_option('acppro_db_version', $acppro_db_version);

	//} else {

 		//Plugin is being re-activated. Check if license is valid and write out license file
                //$license_key=get_option(ACP_LICENSE_KEY_NAME);
                //$res=acppro_activate_license($license_key);
		//echo $res;
	//}

        //write settings to primary host
        //$run_script = "sudo " . ACP_ACCLAIM_HOME . "/bin/settings Init dummy '".ACP_LICENSE_REFERENCE."' &> /dev/null &";
        //$line_number = __LINE__;
        //$results = acp_connect_server(ACP_VIRTUALIZATION_HOST_PRIMARY,ACP_VIRTUALIZATION_ACCOUNT,ACP_VIRTUALIZATION_ACCOUNT_PASSWORD,$run_script,$line_number,$line_number);
}

// Delete table when deleted
function acppro_db_deactivate() {

        global $wpdb;

        $current_user = wp_get_current_user();
        $user_id = $current_user->ID;

        //delete_user_meta($user_id, ACP_LICENSE_KEY_NAME,"");
        delete_option("acppro_db_version");
        delete_option("acppro_license_key");

        //delete settings
        $run_script = "sudo " . ACP_ACCLAIM_HOME . "/bin/settings Delete dummy '".ACP_LICENSE_REFERENCE."' &> /dev/null &";
        $line_number = __LINE__;
        $results = acp_connect_server(ACP_VIRTUALIZATION_HOST_PRIMARY,ACP_VIRTUALIZATION_ACCOUNT,ACP_VIRTUALIZATION_ACCOUNT_PASSWORD,$run_script,$line_number,$line_number);
}

// Delete table when deleted
function acppro_db_remove() {

        global $wpdb;

 	$current_user = wp_get_current_user();
        $user_id = $current_user->ID;

        //delete_user_meta($user_id, ACP_LICENSE_KEY_NAME,"");
        delete_option("acppro_db_version");
        delete_option("acppro_license_key");

        //delete settings
        $run_script = "sudo " . ACP_ACCLAIM_HOME . "/bin/settings Delete dummy '".ACP_LICENSE_REFERENCE."' &> /dev/null &";
        $line_number = __LINE__;
        $results = acp_connect_server(ACP_VIRTUALIZATION_HOST_PRIMARY,ACP_VIRTUALIZATION_ACCOUNT,ACP_VIRTUALIZATION_ACCOUNT_PASSWORD,$run_script,$line_number,$line_number);
}

//allow redirection, even if plugin starts to send output to the browser
function acppro_do_output_buffer() {
        ob_start();
}
add_action('init', 'acppro_do_output_buffer');

add_action('admin_menu', 'acppro_license_menu');

//        register_setting( 'acppro_license_management_page', 'acppro_options' , 'acppro_license_menu_callback');

//send notice if settings have not been made after activating plugin
//https://premium.wpmudev.org/blog/adding-admin-notices/
function acppro_plugin_settings_warn() {

        if (null == get_option(ACP_LICENSE_KEY_NAME)){

                echo ACPPRO_PLUGIN_SETTINGS_ERROR;
        }
}
add_action( 'admin_notices', 'acppro_plugin_settings_warn' );

function acppro_license_menu() {

    	add_options_page('Acclaim Cloud Platform Pro License Key Request & Activation Menu', 'ACP Pro Key', 'manage_options', 'acppro_options', 'acppro_license_management_page');
}

function acppro_license_management_page() {

 	global $current_user;

        $current_user = wp_get_current_user();
        $user_id = $current_user->ID;

	echo '<div class="wrap">';
    	echo '<h2>Acclaim Cloud Platform Pro Key Activation</h2>';

    	/*** License activate button was clicked ***/
    	if (isset($_REQUEST['acppro_activate_license'])) {

        	$license_key = $_REQUEST[ACP_LICENSE_KEY_NAME];
		$res=acppro_activate_license($license_key);
		echo $res;
		//$page = $_SERVER['REQUEST_URI'];
		//$sec = "10";
		//header("Refresh: $sec; url=$page");
		//header("Location: $page");
		//exit();
    	}
    	/*** End of license activation ***/

    	/*** License de-activate button was clicked ***/
    	if (isset($_REQUEST['acppro_deactivate_license'])) {
        	$license_key = $_REQUEST[ACP_LICENSE_KEY_NAME];

        	// API query parameters
        	$api_params = array(
            		'slm_action' => 'slm_deactivate',
            		'secret_key' => ACP_LICENSE_AUTH_SECRET_KEY,
            		'license_key' => $license_key,
            		'registered_domain' => $_SERVER['SERVER_NAME'],
            		'item_reference' => urlencode(ACP_LICENSE_REFERENCE),
        	);

        	// Send query to the license manager server
        	$query = esc_url_raw(add_query_arg($api_params, ACP_LICENSE_SERVER_URL));
        	$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => true));

        	// Check for error in the response
        	if (is_wp_error($response)){
            		echo "Unexpected Error! The query returned with an error.";
        	}

        	// License data.
        	$license_data = json_decode(wp_remote_retrieve_body($response));

        	if($license_data->result == 'success'){//Success was returned for the license activation

            		//the message that returned from the license server
            		echo '<br />The following message was returned from the server: <strong> ' . $license_data->message . '</strong>';

            		//Remove the licensse key from the options table. It will need to be activated again.
            		update_option(ACP_LICENSE_KEY_NAME, '');
        	} else {
            		//Show error to the user. Probably entered incorrect license key.
            		echo '<br />The following error message was returned from the server:  <strong> ' . $license_data->message . '</strong>';
        	}

    	}
    	/*** End of license deactivation ***/

 	/*** Create new License button was clicked ***/
    	if (isset($_REQUEST['acppro_get_developer_license'])) {

       		$licensee_name = $_REQUEST['acppro_licensee_name'];
        	$licensee_email = $_REQUEST['acppro_licensee_email'];

        	// API query parameters
        	$api_params = array(
            		'slm_action' => 'slm_create_new',
            		'secret_key' => ACP_LICENSE_CREATE_SECRET_KEY,
	    		'last_name' => $licensee_name,
			'email' => $licensee_email,
			'date_created' => date('Y-m-d'),
			'date_expiry' => date('Y-m-d', strtotime('+12 months')),
            		'registered_domain' => $_SERVER['SERVER_NAME'],
        	);

        	// Send query to the license manager server
        	$query = esc_url_raw(add_query_arg($api_params, ACP_LICENSE_SERVER_URL),'https');
        	$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));

		//$response_msg=implode(",",$response);
        	// Check for error in the response
        	if (is_wp_error($response)){
            		echo "Unexpected Error! The query returned with an error.";
        	}

        	// License data.
                //file_put_contents('logs.txt', "response: var_dump($response)".PHP_EOL , FILE_APPEND | LOCK_EX);
                //echo 'Response is: ' . var_dump($response);

                $license_data = json_decode(wp_remote_retrieve_body($response));
        	//$license_data = wp_remote_retrieve_body($response);
                //echo 'Response is: ' . var_dump($license_data);
		//echo "Response is: $license_data";

                //$license_data_str=implode(",",$license_data);

        	if($license_data->result == 'success'){//Success was returned for the license activation

            		//the message that returned from the license server
			$license_key=$license_data->key;
            		echo '<br />Here is your new key: <strong> </font>' . $license_key . '</strong>';
			//save license in on the ACP Server
                        //update_user_meta( $user_id, ACP_LICENSE_KEY_NAME, $license_key, "" );
			//Save the license key in the options table
                        add_option(ACP_LICENSE_KEY_NAME, $license_key);
			$res=acppro_activate_license($license_key);
			echo "$res";
        	} else {
            		//Show error to the user. Probably entered incorrect license key.
            		echo '<br />The following error message was returned from the server: <strong> ' . $license_data->message . ' ' . var_dum($license_data) . '</strong>';
        	}

	}
    	/*** End of license creation ***/

	//only display elements if user has not activated the license
	$existing_key_option=get_option(ACP_LICENSE_KEY_NAME);
	//$existing_key_meta=get_user_meta($user_id, ACP_LICENSE_KEY_NAME, true);

  	if ($existing_key_option){

		//client has key and it is activated
		$existing_key_msg="<h3> Existing Key: </h3> <strong> $existing_key_option </strong> <font color='green'>Active</font>";
		$activate_block  = "";

	} else {

		// user does not have license
		$existing_key_msg="";
		$activate_block = '

			<h3> Step 1:</h3>
 			Please request a Development Key here:
    			<form action="" method="post">
        			<table class="form-table">
            				<tr>
                				<th style="width:100px;"><label for="acppro_licensee_name">Company Name</label></th>
                				<td ><input class="regular-text" type="text" id="acppro_licensee_name" name="acppro_licensee_name"  value="" ></td>
            				</tr>
            				<tr>
               					<th style="width:100px;"><label for="acppro_licensee_email">Contact Email</label></th>
                				<td ><input class="regular-text" type="text" id="acppro_licensee_email" name="acppro_licensee_email"  value="" ></td>
            				</tr>
        			</table>
        		<p class="submit">
            		<input type="submit" name="acppro_get_developer_license" value="Get Development ACP Pro" class="button" />
        		</p>
    			</form>
		';

	}

    ?>
    <br>
<?= $existing_key_msg ?>
<p>
<?= $activate_block ?>

<!--
 <h3> Step 2:</h3>

  Please Activate the Key:
    <form action="" method="post">
        <table class="form-table">
            <tr>
                <th style="width:100px;"><label for="acppro_license_key">Key</label></th>
                <td ><input class="regular-text" type="text" id="acppro_license_key" name="acppro_license_key"  value="" ></td>

            </tr>
        </table>
        <p class="submit">
            <input type="submit" name="acppro_activate_license" value="Activate ACP Pro" class="button-primary" />
            <input type="submit" name="acppro_deactivate_license" value="Deactivate ACP Pro" class="button" />
        </p>
	(You may also deactivate an existing Key here)
    </form>

-->
    <?php

    echo '</div>';
}

function acppro_activate_license ($license){

	/// API query parameters
       	$api_params = array(
       		'slm_action' => 'slm_activate',
               	'secret_key' => ACP_LICENSE_AUTH_SECRET_KEY,
               	'license_key' => $license,
               	'registered_domain' => $_SERVER['SERVER_NAME'],
               	'item_reference' => urlencode(ACP_LICENSE_REFERENCE),
       	);

      	// Send query to the license manager server
      	$query = esc_url_raw(add_query_arg($api_params, ACP_LICENSE_SERVER_URL));
       	$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => true));

       	//echo '<br />The following message was returned from the server: '.$response;

       	// Check for error in the response
       	if (is_wp_error($response)){
          	return "Unexpected Error! The query returned with an error.";
       	}

      	// License data.
       	$license_data = json_decode(wp_remote_retrieve_body($response));

       	if(null == ACP_VIRTUALIZATION_HOST || !acp_ping_check(ACP_VIRTUALIZATION_HOST)){
            	return "The ACP Server is not Accessible. Please make sure the ACP Plugin is installed and configured ";
                //die();
      	}

	if(is_admin() && $license_data->result == 'success'){   //Success was returned for the license activation

	        //Uncomment the followng line to see the message that returned from the license server
	        //echo '<br />The key activation was successful: <strong>'.$license_data->message.'</strong>';

	        //Save the license key in the options table
	        //update_option(ACP_LICENSE_KEY_NAME, $license_key);

	        $arr_license=array();
	        //separator is |:|
	        $arr_license[0] = "ACP_LICENSE_AUTH_SECRET_KEY : " . ACP_LICENSE_AUTH_SECRET_KEY;
	        $arr_license[1] = "ACP_LICENSE_SERVER_URL : " . ACP_LICENSE_SERVER_URL;
	        $arr_license[2] = "ACP_LICENSE_KEY : $license";
	        $str_arr_license=implode("|",$arr_license);

	        $run_script = "sudo " . ACP_ACCLAIM_HOME . "/bin/license Activate '$str_arr_license' &> /dev/null &";
	        $line_number = __LINE__;
	        $results = acp_connect_server(ACP_VIRTUALIZATION_HOST,ACP_VIRTUALIZATION_ACCOUNT,ACP_VIRTUALIZATION_ACCOUNT_PASSWORD,$run_script,$line_number,$line_number);

		return "<br />The key activation was successful: <strong>".$license_data->message."</strong> <a href=".$_SERVER['REQUEST_URI'].">Continue</a>";
		//$page = $_SERVER['REQUEST_URI'];
                //$sec = "10";
                //header("Refresh: $sec; url=$page");

      	} else {

              	//Show error to the user. Probably entered incorrect license key.

               	//Uncomment the followng line to see the message that returned from the license server
               	return '<br />The following message was returned from the server: <strong> ' . $license_data->message . '</strong>';
                //echo '<br />The following message was returned from the server: '.$response;
       }

}
